t4150: test applying with a newline in subject
[git/dscho.git] / git-sh-setup.sh
blob80acb7de729f2f824043b592ce110479d4334a06
1 #!/bin/sh
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
14 git_broken_path_fix () {
15 case ":$PATH:" in
16 *:$1:*) : ok ;;
18 PATH=$(
19 SANE_TOOL_PATH="$1"
20 IFS=: path= sep=
21 set x $PATH
22 shift
23 for elem
25 case "$SANE_TOOL_PATH:$elem" in
26 (?*:/bin | ?*:/usr/bin)
27 path="$path$sep$SANE_TOOL_PATH"
28 sep=:
29 SANE_TOOL_PATH=
30 esac
31 path="$path$sep$elem"
32 sep=:
33 done
34 echo "$path"
37 esac
40 # @@BROKEN_PATH_FIX@@
42 die() {
43 echo >&2 "$@"
44 exit 1
47 if test -n "$OPTIONS_SPEC"; then
48 usage() {
49 "$0" -h
50 exit 1
53 parseopt_extra=
54 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
55 parseopt_extra="--keep-dashdash"
57 eval "$(
58 echo "$OPTIONS_SPEC" |
59 git rev-parse --parseopt $parseopt_extra -- "$@" ||
60 echo exit $?
62 else
63 dashless=$(basename "$0" | sed -e 's/-/ /')
64 usage() {
65 die "Usage: $dashless $USAGE"
68 if [ -z "$LONG_USAGE" ]
69 then
70 LONG_USAGE="Usage: $dashless $USAGE"
71 else
72 LONG_USAGE="Usage: $dashless $USAGE
74 $LONG_USAGE"
77 case "$1" in
78 -h|--h|--he|--hel|--help)
79 echo "$LONG_USAGE"
80 exit
81 esac
84 set_reflog_action() {
85 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
86 then
87 GIT_REFLOG_ACTION="$*"
88 export GIT_REFLOG_ACTION
92 git_editor() {
93 : "${GIT_EDITOR:=$(git config core.editor)}"
94 : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
95 case "$GIT_EDITOR,$TERM" in
96 ,dumb)
97 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
98 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
99 echo >&2 "Please set one of these variables to an appropriate"
100 echo >&2 "editor or run $0 with options that will not cause an"
101 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
102 exit 1
104 esac
105 eval "${GIT_EDITOR:=vi}" '"$@"'
108 is_bare_repository () {
109 git rev-parse --is-bare-repository
112 cd_to_toplevel () {
113 cdup=$(git rev-parse --show-cdup)
114 if test ! -z "$cdup"
115 then
116 # The "-P" option says to follow "physical" directory
117 # structure instead of following symbolic links. When cdup is
118 # "../", this means following the ".." entry in the current
119 # directory instead textually removing a symlink path element
120 # from the PWD shell variable. The "-P" behavior is more
121 # consistent with the C-style chdir used by most of Git.
122 cd -P "$cdup" || {
123 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
124 exit 1
129 require_work_tree () {
130 test $(git rev-parse --is-inside-work-tree) = true ||
131 die "fatal: $0 cannot be used without a working tree."
134 get_author_ident_from_commit () {
135 pick_author_script='
136 /^author /{
137 s/'\''/'\''\\'\'\''/g
139 s/^author \([^<]*\) <[^>]*> .*$/\1/
140 s/'\''/'\''\'\'\''/g
141 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
144 s/^author [^<]* <\([^>]*\)> .*$/\1/
145 s/'\''/'\''\'\'\''/g
146 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
149 s/^author [^<]* <[^>]*> \(.*\)$/\1/
150 s/'\''/'\''\'\'\''/g
151 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
156 encoding=$(git config i18n.commitencoding || echo UTF-8)
157 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
158 LANG=C LC_ALL=C sed -ne "$pick_author_script"
161 # Make sure we are in a valid repository of a vintage we understand,
162 # if we require to be in a git repository.
163 if test -z "$NONGIT_OK"
164 then
165 GIT_DIR=$(git rev-parse --git-dir) || exit
166 if [ -z "$SUBDIRECTORY_OK" ]
167 then
168 test -z "$(git rev-parse --show-cdup)" || {
169 exit=$?
170 echo >&2 "You need to run this command from the toplevel of the working tree."
171 exit $exit
174 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
175 echo >&2 "Unable to determine absolute path of git directory"
176 exit 1
178 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
181 # Fix some commands on Windows
182 case $(uname -s) in
183 *MINGW*)
184 # Windows has its own (incompatible) sort and find
185 sort () {
186 /usr/bin/sort "$@"
188 find () {
189 /usr/bin/find "$@"
192 esac